
set working_dir [file dirname [info nameofexe]]
cd $working_dir


set tclkit_runtime [info nameofexe]


set bin_reshacker   bin/reshacker/reshacker.exe
set bin_gorc        bin/gorc.exe
set bin_upx         bin/upx.exe


proc timestamp_format {x} {clock format $x -format "%Y-%m-%d--%H-%M-%S"}
proc now {} {timestamp_format [clock sec]}


proc clean {} {
  catch {
    file delete x0.exe x1.exe x2.exe x3.exe x4.exe x5.exe x_.rc x_.res
  }
}


clean


# build the interp
#
exec tclkitsh sdx.kit qwrap init_interp.tcl -runtime $tclkit_runtime
file rename init_interp x0.exe


# start
#
file copy x0.exe x1.exe


# uncompress the exe so the resources in the exe can be edited
#
exec $bin_upx -d x1.exe


# delete the resources from the uncompressed exe
#
exec $bin_reshacker -delete x1.exe , x2.exe , versioninfo,,
exec $bin_reshacker -delete x2.exe , x3.exe , icongroup,,


# use GoRC to transform RC to RES
#
file copy the.rc x_.rc  ;# make x_.rc
exec $bin_gorc /r x_           ;# make x_.res


# add the resource info to the exe
#
exec $bin_reshacker -add x3.exe , x4.exe , x_.res ,,,


# upx compress the exe
#
file copy x4.exe x5.exe
exec $bin_upx -9 x5.exe


# output the new exe
#
set new_fn znew-[now].exe
file copy -force x5.exe $new_fn
file mtime $new_fn [clock seconds]

clean

