
####xia####winconsole####
console eval {
  bind Console <Control-Key-p> {tk::ConsoleHistory prev}
  bind Console <Control-Key-n> {tk::ConsoleHistory next}
  .console conf -font {"Lucida Console" 14} -bg #dddddd
  destroy .menubar
}
####ixa####

####xia####alt-menu-disable####
proc alt_menu_disable {} {
# remove global bindings that do the alt- menu (specific to this interp)
foreach el [bind all] {
  if {[bind all $el] eq "tk::WinMenuKey %W %N"} {
    bind all $el {}
  }
}
}
alt_menu_disable
####ixa####

####xia####verybase####
proc timestamp_format {x} {clock format $x -format "%Y-%m-%d--%H-%M-%S"}
proc now {} {timestamp_format [clock sec]}
proc sconcat {args} {append x {*}$args}
proc file_get {fn} {set f [open $fn r] ; set c [read $f] ; close $f ; return $c}
proc file_save {fn x} {set f [open $fn w] ; puts -nonewline $f $x ; close $f}
proc bin_file_get {fn} {set f [open $fn r] ; fconfigure $f -translation binary -encoding binary ; set c [read $f] ; close $f ; return $c}
proc bin_file_save {fn x} {set f [open $fn w] ; fconfigure $f -translation binary -encoding binary ; puts -nonewline $f $x ; close $f}
proc ? {} {set ::errorInfo}
####ixa####

####xia####verybase-bin####
proc to_hex {bytearray} {binary scan $bytearray H* hex; return $hex}
proc from_hex {hex} {set bytearray [binary format H* $hex]}
proc u32_to_bin {decimal} {set bytearray [binary format Iu $decimal]}
proc u32_to_dec {bytearray} {binary scan $bytearray Iu decimal ; return $decimal}

proc fbin_offsets {fn begin end} {
  set len [expr $end - $begin + 1]
  set f [open $fn r]
  fconfigure $f -translation binary -encoding binary
  seek $f $begin
  set data [read $f $len]
  close $f
  return $data
}
####ixa####

####xia####dict-utils####
proc dict_set_vars {d args} {
  foreach vname $args {
    set value [dict get $d $vname]
    uplevel [list set $vname $value]
  }
}

proc dget {d key elseval} {
  if {[dict exists $d $key]} {
    return [dict get $d $key]
  }
  return $elseval
}
####ixa####

####xia####eq-alias####
interp alias {} eq {} string equal
####ixa####

####xia####nsprocs####
proc link {args} {
  set vname [lindex $args 0]
  set ns [uplevel {set thisns}]
  set vns ${ns}::$vname
  uplevel [list upvar $vns $vname]
  if {[llength $args] == 2} {set $vns [lindex $args 1]}
}

proc links {args} {
  foreach vn $args {
    uplevel [list link $vn]
  }
}

proc linkall {} {
  set ns [uplevel {set thisns}]
  uplevel [list ns_upvar_all $ns]
}

# call from ::bim::some_proc, and it will link all namespace variables.
#
proc link_ns_vars {} {

  # ::bim
  set ns [uplevel {namespace current}]

  # ::bim::alpha ::bim::beta
  foreach fq_v [info vars ${ns}::*] {

    # alpha
    set v [namespace tail $fq_v]

    # uplevel {upvar ::bim::alpha alpha}
    uplevel [list upvar $fq_v $v]
  }

  return
}

proc nsvalue {ns varname} {
  set [sconcat $ns :: $varname]
}

proc ns_upvar {ns args} {
  foreach vname $args {
    set vns ${ns}::$vname
    uplevel [list upvar #0 $vns $vname]
  }
}

proc ns_upvar_all {ns} {

  # ::bim

  # ::bim::alpha ::bim::beta
  foreach fq_v [info vars ${ns}::*] {

    # alpha
    set v [namespace tail $fq_v]

    # uplevel {upvar ::bim::alpha alpha}
    uplevel [list upvar $fq_v $v]
  }

  return
}
####ixa####



####xia####txcursor####
namespace eval ::txcursor:: {}

proc ::txcursor::jump_cursor {tx ix} {
  $tx mark set insert $ix
  $tx see insert
}

proc ::txcursor::is_whitespace {s} {
  expr {[string is space -strict $s]}
}

proc ::txcursor::get_char_forward {tx ix} {
  $tx get $ix [sconcat $ix +1c]
}
proc ::txcursor::get_char_backward {tx ix} {
  $tx get [sconcat $ix -1c] $ix
}

proc ::txcursor::group_forward {tx} {

  set ix [$tx index insert]

  set s    [::txcursor::get_char_forward $tx $ix]
  set g_ws [::txcursor::is_whitespace $s]

  while {$ix ne "end"} {
    set s    [::txcursor::get_char_forward $tx $ix]
    set c_ws [::txcursor::is_whitespace $s]

    if {$c_ws != $g_ws} break
    set ix [$tx index [sconcat $ix +1c]]
  }

  ::txcursor::jump_cursor $tx $ix
}


proc ::txcursor::group_backward {tx} {

  set ix [$tx index insert]

  set s    [::txcursor::get_char_backward $tx $ix]
  set g_ws [::txcursor::is_whitespace $s]

  while {$ix ne "1.0"} {
    set s    [::txcursor::get_char_backward $tx $ix]
    set c_ws [::txcursor::is_whitespace $s]

    if {$c_ws != $g_ws} break
    set ix [$tx index [sconcat $ix -1c]]
  }

  ::txcursor::jump_cursor $tx $ix
}
####ixa####



####xia####tx_utils####

proc tx_num_matches {tx findtext} {
  set c [$tx get 1.0 end]
  llength [string_find_matches $c $findtext]
}

proc tx_center_line {tx} {
  lassign [$tx bbox insert] _ iy _ _
  set TY [winfo height $tx]
  set distance_to_middle [expr $iy - ($TY / 2.0)]
  $tx yview scroll $distance_to_middle pixels
}

proc tx_jump_to_begin {tx} {
  $tx mark set insert 1.0
  $tx see insert
}
proc tx_jump_to_end {tx} {
  $tx mark set insert end
  $tx see insert
}

proc tx_load_file {tx fn where_insert} {
  $tx del 1.0 end
  $tx ins end [file_get $fn]
  update  ;# without this the insert cursor is not always seen
  $tx mark set insert $where_insert
  $tx see insert
  $tx edit reset
}

####ixa####



####xia####tx_scroll####

proc tx_scroll {tx n} {
  $tx yview scroll $n pixels
  tx_scroll__aux__if_insert_isnt_visible_set_to_center $tx
}

proc tx_scroll__aux__if_insert_isnt_visible_set_to_center {tx} {
  lassign [$tx bbox insert] _ iy _ _
  set hei [winfo height $tx]
  if {($iy eq "") || ($iy < 0) || ([expr $hei - $iy] < 20)} {
    $tx mark set insert @0,[expr $hei / 2]
  }
}

proc tx_scroll_setup_bind {tx} {

bind $tx <MouseWheel> {
  if {%D >= 0} {
    tx_scroll %W -80
  } else {
    tx_scroll %W 80
  }
  break
}

bind $tx <Control-MouseWheel> {
  if {%D >= 0} {
    tx_scroll %W -160
  } else {
    tx_scroll %W 160
  }
  break
}

bind $tx <F1> [list tx_scroll $tx -40]
bind $tx <F2> [list tx_scroll $tx 40]
bind $tx <F11> [list tx_scroll $tx -80]
bind $tx <F12> [list tx_scroll $tx 80]
bind $tx <Control-F11> [list tx_scroll $tx -160]
bind $tx <Control-F12> [list tx_scroll $tx 160]

} ;# end tx_scroll_setup_bind

####ixa####


####xia####tx_customize####

font create Font_as_i_like -size 14 -family Georgia

proc tx_configure_as_i_like {tx} {

  $tx conf -relief flat -undo 1 -wrap word \
    -insertwidth 4 -font Font_as_i_like

  $tx conf -bg black -fg #cccccc -insertbackground magenta
  $tx conf -inactiveselectbackground magenta -selectbackground magenta -selectforeground white

  tx_setup_full_bindings $tx

}

proc tx_setup_full_bindings {tx} {

  # control-shift-a  is select all
  bind $tx <Control-A> {%W tag add sel 1.0 end-1c}

  # control-shift-z is redo, and we already have control-z for undo
  bind $tx <Control-Z> {event generate %W <<Redo>>}

  # two spaces instead of tabs
  bind $tx <Tab> {%W insert "insert" "  " ; break}

  # alt-b and alt-f jump words like emacs
  bind $tx <Alt-b> [list ::txcursor::group_backward $tx]
  bind $tx <Alt-f> [list ::txcursor::group_forward  $tx]

  # center vertically
  bind $tx <Control-l> [list tx_center_line $tx]

  # emacs like alt-> alt-<
  bind $tx <Alt-KeyPress-less> [list tx_jump_to_begin $tx]
  bind $tx <Alt-KeyPress-less> +break
  bind $tx <Alt-KeyPress-greater> [list tx_jump_to_end $tx]
  bind $tx <Alt-KeyPress-greater> +break

  # the tx should be set to use a named font
  bind $tx <F3> [list tx_decrease_named_font $tx]
  bind $tx <F4> [list tx_increase_named_font $tx]

  # tx_scroll
  tx_scroll_setup_bind $tx

}

proc tx_decrease_named_font {tx} {
  set fontname [$tx cget -font]
  set xsize [font configure $fontname -size]
  if {$xsize == 1} return
  incr xsize -1
  font configure $fontname -size $xsize
}

proc tx_increase_named_font {tx} {
  set fontname [$tx cget -font]
  set xsize [font configure $fontname -size]
  incr xsize
  font configure $fontname -size $xsize
}

####ixa####


####xia####EEVAL####
proc EEVAL {} {
  toplevel .eeval
  set tx .eeval.tx

  text $tx -bg #eeeeee -fg black -font {{Lucida Console} 14} \
    -insertbackground black -insertwidth 4 -wrap none -undo 1
  pack $tx -fill both -expand 1

  wm geom .eeval 785x400

  focus -force $tx

  # control-shift-a  is select all
  bind $tx <Control-A> {%W tag add sel 1.0 end-1c}

  # control-shift-z is redo, and we already have control-z for undo
  bind $tx <Control-Z> {event generate %W <<Redo>>}

  # two spaces instead of tabs
  bind $tx <Tab> {%W insert "insert" "  " ; break}

  bind $tx <Control-Return> EEVAL_do
  bind $tx <Control-Return> +break

}
proc EEVAL_do {} {
  set tx .eeval.tx

  set c \n
  append c [string trim [$tx get 1.0 end-1c]]
  append c \n

  console eval [list tk::ConsoleInsert .console $c]
  console eval {
    tk::ConsoleInvoke
    .console mark set insert end-1c
  }
}

bind all <Alt-F12> EEVAL
####ixa####




# ==title== string-utils
####xia####string-utils####

proc string_find_matches {c findtext} {
  set z {}
  set si 0
  while 1 {
    set ix [string first $findtext $c $si]
    if {$ix == -1} break
    lappend z $ix
    set si [expr $ix + [string length $findtext]]
  }
  return $z
}

# x is given, replace first occurence of string a with string b.
proc string_replace_one {x a b} {
  set ix [string first $a $x]
  if {$ix == -1} {return $x}
  set ix_end [expr $ix + [string length $a] - 1]
  string replace $x $ix $ix_end $b
}

# x is given, replace all instances of a with b.
proc string_replace_all {x a b} {
  string map [list $a $b] $x
}

proc string_split_on_matches {c findtext} {
  set z {}
  set si 0
  while 1 {
    set ix [string first $findtext $c $si]
    if {$ix == -1} break
    lappend z [string range $c $si [expr $ix - 1]]
    set si [expr $ix + [string length $findtext]]
  }
  lappend z [string range $c $si end]
  return $z
}

proc string_from_this_until_end {c s0} {
  set i0 [string first $s0 $c]
  if {$i0 == -1} {return {}}
  set ni [expr $i0 + [string len $s0]]
  string range $c $ni end  
}

proc string_between {c s0 s1} {
  set i0 [string first $s0 $c]
  if {$i0 == -1} {return {}}
  set ni [expr $i0 + [string len $s0]]
  set i1 [string first $s1 $c $ni]
  if {$i1 == -1} {return {}}
  string range $c $ni [expr $i1 - 1]
}

proc all_strings_between {c xbegin xend} {
  set z {}
  set si 0
  while 1 {
    set ix [string first $xbegin $c $si]
    if {$ix == -1} break
    set si [expr $ix + [string length $xbegin]]
    set b0 $si

    set ix [string first $xend $c $si]
    if {$ix == -1} break
    set si [expr $ix + [string length $xend]]
    set b1 [expr $ix - 1]
  
    lappend z [string range $c $b0 $b1]
  }
  return $z
}

####ixa####



####xia####tx_jfind####

proc tx_jfind_back {tx findtext} {
  if {$findtext eq ""} return

  set c [$tx get 1.0 insert]
  set clen [string length $c]

  set abs_ix [lindex [string_find_matches $c $findtext] end]
  if {$abs_ix eq ""} return
  set kk [expr $clen - $abs_ix]

  $tx mark set insert "[$tx index insert] - $kk c"
  $tx see insert
}

proc tx_jfind_fwd {tx findtext} {
  if {$findtext eq ""} return

  set c [$tx get "insert + 1c" end]
  set clen [string length $c]

  set abs_ix [lindex [string_find_matches $c $findtext] 0]
  if {$abs_ix eq ""} return
  set kk [expr $abs_ix + 1]

  $tx mark set insert "[$tx index insert] + $kk c"
  $tx see "insert + 5lines"
}

####ixa####


####xia####scrollify####
namespace eval ::scrollify:: {}

proc scrollify {given_c given_m} {
  set thisns ::scrollify::$given_c  ;# ns in the form ::scrollify::.c
  namespace eval $thisns {}

  link c $given_c ; link m $given_m
  link barpx 6

  bind $c <Destroy> [list scrollify_destroyed $thisns]

  $c conf -highlightthickness 0 -bg black

  $c create rectangle 0 0 0 0 -fill #888888 -width 0 -tags "yyybg Yside Items"
  $c create rectangle 0 0 0 0 -fill yellow -width 0 -tags "aaa Yside Items"

  $c create rectangle 0 0 0 0 -fill #888888 -width 0 -tags "xxxbg Xside Items"
  $c create rectangle 0 0 0 0 -fill yellow -width 0 -tags "qqq Xside Items"

  # panning box
  ##$c bind Yside <Enter> [list scrollify_yenter $thisns]

  # managed window
  $c create window 0 0 -window $m -anchor nw -width 0 -height 0 -tags $m

  bind $c <Configure> [list scrollify_reconfed $thisns]
  
  $m conf -yscrollcommand [list scrollify_yscrolled $thisns]
  $m conf -xscrollcommand [list scrollify_xscrolled $thisns]

}

proc scrollify_destroyed {thisns} {
  namespace delete $thisns
}

proc scrollify_reconfed {thisns} {
  linkall

  set w [winfo width $c]
  set h [winfo height $c]

  set mw [expr {$w - $barpx}]
  set mh [expr {$h - $barpx}]
  $c itemconfigure $m -width $mw -height $mh

  $c coords yyybg [expr {$w - $barpx}] 0 $w $h
  $c coords xxxbg 0 [expr {$h - $barpx}] $w $h

}

proc scrollify_yenter {thisns} {
  linkall

  set t $c.t

  if {[winfo exists $t]} {destroy $t}
  toplevel $t -bg magenta
  focus -force $t

  bind $t <Leave> [list destroy $t]
  ##bind $t <Control-Down> [list p %K]

  wm attr $t -alpha 0.5
  wm overrideredirect $t 1

  set x [winfo rootx $c]
  set y [winfo rooty $c]

  set px [winfo pointerx .]
  set py [winfo pointery .]

  set ox [expr $px - 20]
  set oy [expr $py - 20]
  wm geom $t 40x40+$ox+$oy

if 0 {
  set w [winfo width $c]
  set h [winfo height $c]

  set ox [expr $x + $w - 30]
  set oy $y

  wm geom $t 30x$h+$ox+$oy
}


}

proc scrollify_yscrolled {thisns b0 b1} {
  linkall

  # if all is shown, zero dimensions
  if {($b0 eq "0.0") && ($b1 eq "1.0")} {
    $c coords aaa 0 0 0 0
    return
  }

  set w [winfo width $c]
  set h [winfo height $c]

  # height of percent displayed indicator
  set ph [expr round(($b1 - $b0) * $h)]

  lassign [list [expr $w - $barpx] 0 $w $ph ] x1 y1 x2 y2

  # offset by where the indicator is
  set offset [expr round($b0 * $h)]
  incr y1 $offset
  incr y2 $offset
  
  $c coords aaa $x1 $y1 $x2 $y2

}

proc scrollify_xscrolled {thisns b0 b1} {
  linkall

  # if all is shown, zero dimensions
  if {($b0 eq "0.0") && ($b1 eq "1.0")} {
    $c coords qqq 0 0 0 0
    return
  }

  set w [winfo width $c]
  set h [winfo height $c]

  # width of percent displayed indicator
  set pw [expr round(($b1 - $b0) * $w)]

  set x1 0
  set y1 [expr $h - $barpx]
  set x2 $pw
  set y2 $h

  # offset by where the indicator is
  set offset [expr round($b0 * $w)]
  incr x1 $offset
  incr x2 $offset

  $c coords qqq $x1 $y1 $x2 $y2

}
####ixa####



# ==title== prograM BeginS

proc p {x} {puts $x}

bind all <Alt-F2> {puts [winfo containing [winfo pointerx %W] [winfo pointery %W]]}
bind all <Alt-F10> {console show}
bind all <Control-q> exit

console show
focus -force .



# ==title== vitalityyyyy vital life blood of the universe rain down on me

namespace eval ::vitality:: {}

proc make_new_tx {} {

  set clockn [clock micro]

  set thisns ::vitality::$clockn
  namespace eval $thisns {}

  link id $clockn
  link t .vitality_$id

  toplevel $t
  bind $t <Control-F2> [list p $thisns]  ;# display identity

  link c $t.c
  link tx $c.tx

  canvas $c
  text $tx
  scrollify $c $tx
  pack $c -fill both -expand 1

  tx_configure_as_i_like $tx
  $tx conf -wrap none

  link font font_$id
  font create $font -family "Lucida Console" -size 18

  $tx conf -font $font

  
  wm geom $t 650x400

  focus -force $tx

  tx_load_file $tx lipsum-code.txt 1.0

}

bind all <Alt-F1> make_new_tx

font create ProgramFont -family "Lucida Console" -size 18


canvas .c
text .c.tx
scrollify .c .c.tx
pack .c -fill both -expand 1

set tx .c.tx

tx_configure_as_i_like $tx
$tx conf -font ProgramFont -wrap none

wm geom . 650x400
wm state . zoomed
focus -force $tx
tx_load_file $tx lipsum-code.txt 1.0


toplevel .tt
set ttx .tt.tx
$tx peer create $ttx
tx_configure_as_i_like $ttx
font create ttxFont -family "Lucida Console" -size 10
$ttx conf -font ttxFont
$ttx conf -wrap none
pack $ttx -fill both -expand 1
wm geom .tt 800x600


